# Copyright (c) 2012-2015 Farsight Security, Inc.
# All Rights Reserved
#
# THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF FARSIGHT SECURITY, INC.
# The copyright notice above does not evidence any
# actual or intended publication of such source code.

from cStringIO import StringIO
import datetime

def padded_split(s, sep, n):
    s = s.split(sep)
    if len(s) < n:
        s.extend([None] * (n - len(s)))
    return s

def pager(iterator, max_bytes=4096):
    buf = StringIO()

    for chunk in iterator:
        buf.write(chunk)

        if buf.tell() >= max_bytes:
            yield buf.getvalue()
            buf = StringIO()
    else:
        if buf.getvalue():
            yield buf.getvalue()

def iso8601now():
    return datetime.datetime.utcnow().isoformat() + 'Z'

def get_method_args(env):
    s = env.get('REQUEST_URI', None)
    if s:
        # REQUEST_URI has the query string appended to it, so we need to remove
        # that part before returning 'args'.
        method, sep, args = s.strip('/').partition('/')
        args = args.partition('?')[0]
        return method, args
    else:
        raise ValueError, "REQUEST_URI not available from WSGI environment"

def format_http500(logid):
    return '''
<html>
<head><title>500 Internal Server Error</title></head>
<body>
<p>An internal server error has occurred. The log ID for this error is: {}.</p>
<p>Sorry about that.</p>
</body>
</html>
'''.format(logid).strip()
