Running dnsdb-api-server under uwsgi for local development
------------------------------------------------

Note that dnsdb-api-server is only supported under Debian-based and CentOS 7.x Linux 
distributions.

First, install a recent version (2.x or newer) of the [uWSGI
application server], it is available in main or secondary official
repositories for both Debian stretch and CentOS 7.x Linux.  Documentation is
available at [uWSGI application server](https://uwsgi-docs.readthedocs.org/en/latest/).

Example uWSGI config files are shipped in the `examples/uwsgi/`
directory.  `localdev_dnstli_api.ini` runs the server with API key
authentication.  `localdev_dnstli_noauth.ini` runs the server with no
authentication (aka open).
They use uWSGI's built-in HTTP server to listen on `127.0.0.1`.

Config files for `dnsdb-api-server` including authentication credentials must be set up in
`/etc/dnstli`. You will also want at least a small sample of `dnstable` data
locally so that actual data will be returned by the lookup server. This is not
covered here.

To run the localdev API server, invoke the following command from the top
directory of the `dnsdb-api-server` working tree (or substitute noauth for api):

```
uwsgi --ini examples/uwsgi/localdev_dnstli_api.ini
```

The API server is now listening on `http://127.0.0.1:65080` (HTTP, not HTTPS),
and can be used with the `dnsdb_query` script when the `DNSDB_SERVER` variable
is set to `"127.0.0.1:65080"`.

